IF OBJECT_ID('_OPZXML_EXPORTTAXSALEDONE') IS NOT NULL
   DROP PROCEDURE _OPZXML_EXPORTTAXSALEDONE
IF OBJECT_ID('_OPZXML_EXPORTTAXSALE') IS NOT NULL
   DROP PROCEDURE _OPZXML_EXPORTTAXSALE
GO


---------------------------------------------------------------------
-- NAME   : PROCEDURE _OPZXML_ExportTaxSaleDone
-- NOTE   :        OPZ
-- ALTER  : 30.01.12 star
---------------------------------------------------------------------
CREATE PROCEDURE _OPZXML_ExportTaxSaleDone
  @DOCUM_ID  int,                        --  
  @FILE_NAME VARCHAR(240) ,              --    
  @MESSAGE   VARCHAR(240) = null OUTPUT  --   
AS
DECLARE
  @RESULT     INT,
  @EDOC_TAXSALE_C_DOC_TYPE INT,
  @C_DOC_TYPE VARCHAR(2)

SET @RESULT = 0

update INVOICE_TAX set  
    DOCUM_STATE_EI = 1,
    DOCUM_EXTCOMMENT = @FILE_NAME
  WHERE DOCUM_ID = @DOCUM_ID
if(@@error <> 0)
begin
  set @MESSAGE = '   '
  SET @RESULT = 1
  goto finish
end  

SELECT @EDOC_TAXSALE_C_DOC_TYPE = convert(int,CONSTUSER_VALUE)
  from constants_user 
 where CONSTUSER_ID = 'EDOC_TAXSALE_C_DOC_TYPE' and isnumeric(CONSTUSER_VALUE) = 1

select @C_DOC_TYPE = ISNULL(NOTE_TEXT,'0')
  FROM NOTE_INVOICE_TAX 
  WHERE DOCUM_ID = @DOCUM_ID
    and TYPE_NOTE_ID = @EDOC_TAXSALE_C_DOC_TYPE
    
if (@C_DOC_TYPE is null)
  INSERT INTO NOTE_INVOICE_TAX ( DOCUM_ID, TYPE_NOTE_ID, NOTE_TEXT)
     VALUES ( @DOCUM_ID, @EDOC_TAXSALE_C_DOC_TYPE, '0' )
else
begin
  set @C_DOC_TYPE = substring(@FILE_NAME, 24, 2)
  update NOTE_INVOICE_TAX set NOTE_TEXT = @C_DOC_TYPE
    WHERE DOCUM_ID = @DOCUM_ID
      and TYPE_NOTE_ID = @EDOC_TAXSALE_C_DOC_TYPE
end
if(@@error <> 0)
begin
  set @MESSAGE = '   '
  SET @RESULT = 2
  goto finish
end  
         
finish:

RETURN @RESULT
---------------------------------------------------------------------
GO

---------------------------------------------------------------------
-- NAME   : PROCEDURE _OPZXML_ExportTaxSale
-- NOTE   :      OPZ
-- CREATE : 20.01.12 star
-- ALTER  : 27.01.12 vsh
-- ALTER  : 03.02.12 vsh   -   !, + 
-- ALTER  : 07.02.12 vsh 8   
-- ALTER  : 10.02.12 vsh      .  ...
-- ALTER  : 15.02.12 vsh ltrim(rtrim())
-- FIX    : 16.02.12 vsh R03G7-R03G11
-- FIX    : 28.02.12 vsh    @coma
-- upd    : 05.03.14 misha    ( @C_DOC_VER= '5' )
-- FIX    : 27.03.14 star  ..  J\F+1201005.xsd
-- ALTER  : 12.12.14 vsh  J\F+1201006
-- FIX	  : 17.12.14 Dm  top 1   볺
---------------------------------------------------------------------
CREATE PROCEDURE _OPZXML_ExportTaxSale
  @DOCUM_ID  int,                        --  
  @FILE_NAME VARCHAR(240)        OUTPUT, --    
  @MESSAGE   VARCHAR(240) = null OUTPUT  --   
AS
DECLARE
  @NULL_VALUE varchar(15),
  @RESULT     INT,
  @SLASH      INT,
  @coma       INT,
  @ColNumb    INT,
  @CNAME1     varchar(20), 
  @CVAL1      varchar(250),

  @CALEND_END DATETIME,
  @C_REG      varchar(2),
  @C_RAJ      varchar(2),
  @C_STI_ORIG varchar(4),
  @TIN        varchar(20), 
  @D_FILL       varchar(8),
  
  @INVTAX_IS_CORRECT int,
  @DOCUM_STATE    int, 
  @DOCUM_STATE_EI int, 
  @DOCUM_DATE     datetime, 
  @ENTERPRISE_ID  int,
  @SELFENTER_ID   int,
  @ENTERPRISE_ISTAXPAYD int,
  @ENTERPRISE_ISPEOPLE int,
  @DOCUM_NUMB     char(15),  
  @docum_basis    varchar(250),
  @TYPE_NOTE_NAME varchar(100),
  @LINE_NUMBER    varchar(10),
  
  @C_DOC         VARCHAR(3),
  @C_DOC1        CHAR(1),
  @C_DOC_SUB     VARCHAR(3),
  @C_DOC_VER     VARCHAR(2),
  @C_DOC_STAN    VARCHAR(1),
  @C_DOC_TYPE    VARCHAR(2),
  @C_DOC_CNT     VARCHAR(7),
  @PERIOD_TYPE   CHAR(1),
  @PERIOD_MONTH  VARCHAR(2),
  @PERIOD_YEAR   VARCHAR(4),
  @EDOC_TAXSALE_C_DOC_TYPE INT,

--HEADER
@HORIG        VARCHAR(2),
@HERPN        VARCHAR(2),
@HORIG1       VARCHAR(2),
@HTYPR        VARCHAR(2),
@HFILL        VARCHAR(10),
@HNUM         VARCHAR(20),
@HNUM1        VARCHAR(20),
@HNUM2        VARCHAR(20),
@HNAMESEL     VARCHAR(250),
@HNAMEBUY     VARCHAR(250),
@HKSEL        VARCHAR(12),
@HKBUY        VARCHAR(12),
@HLOCSEL      VARCHAR(250),
@HLOCBUY      VARCHAR(250),
@HTELSEL      VARCHAR(100),
@HTELBUY      VARCHAR(100),
@H01G1S       VARCHAR(250),
@H01G2D       VARCHAR(10),
@H01G3S       VARCHAR(20),
@H02G1S       VARCHAR(240),
--LINES
--SUMMARY
@R01G7        VARCHAR(20),
@R01G109      VARCHAR(20),
@R01G8        VARCHAR(20),
@R01G9        VARCHAR(20),
@R01G10       VARCHAR(20),
@R01G11       VARCHAR(20),
@R02G11       VARCHAR(20),
@R03G7        VARCHAR(20),
@R03G109      VARCHAR(20),
@R03G8        VARCHAR(20),
@R03G9        VARCHAR(20),
@R03G10S      VARCHAR(20),
@R03G11       VARCHAR(20),
@R04G7        VARCHAR(20),
@R04G109      VARCHAR(20),
@R04G8        VARCHAR(20),
@R04G9        VARCHAR(20),
@R04G10       VARCHAR(20),
@R04G11       VARCHAR(20),
@R003G10S     VARCHAR(80),
@H10G1S       VARCHAR(20),
@XSD          varchar(400)

set @XSD     = '1201006.xsd'
SET @RESULT = 0
SET @MESSAGE = 'Ok'
SET @NULL_VALUE = ' xsi:nil="true"'

--  
delete from #opzxml_lines

--         
SELECT @C_REG = ltrim(rtrim(isnull(CONSTUSER_VALUE,'')))
  from constants_user where CONSTUSER_ID = 'EDOC_TAXSALE_C_REG'
SELECT @C_RAJ = ltrim(rtrim(isnull(CONSTUSER_VALUE,'')))
  from constants_user where CONSTUSER_ID = 'EDOC_TAXSALE_C_RAJ'
SELECT @C_STI_ORIG = ltrim(rtrim(isnull(CONSTUSER_VALUE,'')))
  from constants_user where CONSTUSER_ID = 'EDOC_TAXSALE_C_STI_ORIG'
  
SELECT @PERIOD_TYPE = ltrim(rtrim(isnull(CONSTUSER_VALUE,'')))
  from constants_user where CONSTUSER_ID = 'EDOC_TAXSALE_PERIOD_TYPE'  

SELECT @EDOC_TAXSALE_C_DOC_TYPE = convert(int,CONSTUSER_VALUE)
  from constants_user 
 where CONSTUSER_ID = 'EDOC_TAXSALE_C_DOC_TYPE' and isnumeric(CONSTUSER_VALUE) = 1
  
IF LEN(ISNULL(@C_REG,'')) <> 2 or
   LEN(ISNULL(@C_RAJ,'')) <> 2 or
   LEN(ISNULL(@C_STI_ORIG,'')) <> 4 or
   LEN(ISNULL(@PERIOD_TYPE,'')) <> 1 or
   ISNUMERIC (@EDOC_TAXSALE_C_DOC_TYPE) <> 1
BEGIN
  SET @MESSAGE = '    . .!'
  SET @RESULT = 1 
  GOTO finish
END    

IF NOT EXISTS(SELECT TOP 1 1 FROM TYPE_NOTE WHERE TYPE_NOTE_ID = @EDOC_TAXSALE_C_DOC_TYPE)
BEGIN
  SET @MESSAGE = '  ,  <EDOC_TAXSALE_C_DOC_TYPE>!'
  SET @RESULT = 1 
  GOTO finish
END    

SELECT 
      @TIN = ltrim(rtrim(ENTERPRISE_COD)),
      @C_DOC_TYPE = ISNULL(n.NOTE_TEXT,'0'),
      @PERIOD_MONTH = CONVERT(VARCHAR(2), MONTH(DOCUM_DATE)), 
      @PERIOD_YEAR = CONVERT(VARCHAR(4), YEAR(DOCUM_DATE)), 
      @D_FILL = REPLACE(CONVERT(VARCHAR(10), DOCUM_DATE, 104),'.',''),
      @INVTAX_IS_CORRECT = d.INVTAX_IS_CORRECT,
      @ENTERPRISE_ISTAXPAYD = e1.ENTERPRISE_ISTAXPAYD,
      @ENTERPRISE_ISPEOPLE = e1.ENTERPRISE_ISPEOPLE,
      @docum_numb = d.docum_numb,
      @ENTERPRISE_ID = d.ENTERPRISE_ID,
      @SELFENTER_ID  = d.SELFENTER_ID,
      @docum_basis = ltrim(rtrim(d.docum_basis)),
      @H02G1S = ltrim(isnull(pm.PAYMETH_NAME,'')),
      @R02G11 = convert(varchar(30), isnull(INVTAX_PACKAGE,0)),

      @R03G7  = CASE WHEN d.INVTAX_TYPE = 0 and d.DOCUM_TAX_PROCENT = 20 then convert(varchar(30),DOCUM_INTAX_HOME) else '' END,
      @R03G109= CASE WHEN d.INVTAX_TYPE = 0 and d.DOCUM_TAX_PROCENT = 7 then convert(varchar(30),DOCUM_INTAX_HOME) else '' END,
      @R03G8  = CASE WHEN d.INVTAX_TYPE = 1 then convert(varchar(30),DOCUM_INTAX_HOME) else '' END,
      @R03G9  = CASE WHEN d.INVTAX_TYPE = 2 then convert(varchar(30),DOCUM_INTAX_HOME) else '' END,
      @R03G10S  = CASE WHEN d.INVTAX_TYPE = 3 
                    THEN CASE WHEN ISNULL(c.COMMENT_TEXT,'') = '' THEN '  .197.1.' ELSE '  ' + c.COMMENT_TEXT END
                  ELSE '' END,

      @R03G11 = convert(varchar(30),DOCUM_INTAX_HOME),
      
      @R04G7  = CASE WHEN d.INVTAX_TYPE = 0 and d.DOCUM_TAX_PROCENT = 20 THEN convert(varchar(30),DOCUM_SUMM_HOME) ELSE '' END,
      @R04G109 = CASE WHEN d.INVTAX_TYPE = 0 and d.DOCUM_TAX_PROCENT = 7 THEN convert(varchar(30),DOCUM_SUMM_HOME) ELSE '' END,
      @R04G8  = CASE WHEN d.INVTAX_TYPE = 1 THEN convert(varchar(30),DOCUM_SUMM_HOME) ELSE '' END,
      @R04G9  = CASE WHEN d.INVTAX_TYPE = 2 THEN convert(varchar(30),DOCUM_SUMM_HOME) ELSE '' END,
      @R04G10 = CASE WHEN d.INVTAX_TYPE = 3 THEN convert(varchar(30),DOCUM_SUMM_HOME) ELSE '' END,
      @R04G11 = convert(varchar(30),DOCUM_SUMM_HOME),      
      @R003G10S  = CASE WHEN d.INVTAX_TYPE = 3 
                    THEN CASE WHEN ISNULL(c.COMMENT_TEXT,'') = '' THEN '³   .197.1.      197  V   '
                                                                  ELSE '³   ' + c.COMMENT_TEXT + '  197  V   ' END
                   ELSE '' END,
      @H10G1S = CASE WHEN d.DOCUM_PEOPLE_ID IS NOT NULL
                     THEN pp.PEOPLE_FNAME + ' ' + pp.PEOPLE_NAME + ' ' + pp.PEOPLE_LNAME
                     ELSE '' END

FROM INVOICE_TAX d
       inner join SELF_ENTERPRISE se on se.SELFENTER_ID = d.SELFENTER_ID
       inner join ENTERPRISE e1 on e1.ENTERPRISE_ID = se.ENTERPRISE_ID      
       LEFT JOIN  PAY_METHOD pm ON pm.PAYMETH_ID = d.PAYMETH_ID
       LEFT JOIN  COMMENT AS c ON (d.COMMENT = c.COMMENT)
       LEFT JOIN  PEOPLE pp ON d.DOCUM_PEOPLE_ID = pp.PEOPLE_ID
       LEFT JOIN  NOTE_INVOICE_TAX n ON d.DOCUM_ID = n.DOCUM_ID and n.TYPE_NOTE_ID = @EDOC_TAXSALE_C_DOC_TYPE
WHERE d.DOCUM_ID = @DOCUM_ID

SET @HTYPR = ''
    
SELECT @HTYPR = ISNULL(RIGHT(RTRIM(TYPE_NOTE_NAME),2),'')
FROM TYPE_NOTE t     
 INNER JOIN NOTE_INVOICE_TAX i ON t.TYPE_NOTE_ID = i.TYPE_NOTE_ID                                                                                              
WHERE i.DOCUM_ID = @DOCUM_ID AND                                                             
 UPPER(LEFT(LTRIM(TYPE_NOTE_NAME),22)) = '  '    

SET @HFILL = @D_FILL

IF ISNULL(@ENTERPRISE_ISPEOPLE,0) = 0
    SET @C_DOC1 = 'J'
ELSE
    SET @C_DOC1 = 'F'
set @XSD = @C_DOC1 + @XSD

IF @INVTAX_IS_CORRECT = 0
BEGIN
  SET @C_DOC = @C_DOC1+'12'
  SET @C_DOC_SUB = '010'
END
ELSE
BEGIN
  SET @C_DOC = @C_DOC1+'12'
  SET @C_DOC_SUB = '012'
END  
  
--1
SET @HORIG = '1'
SET @HERPN= '1'
SET @HORIG1 = ''

IF @HTYPR<>''
  SET @HORIG1 = '1'

--2
SET @HNUM1 = ''

SET @slash = CHARINDEX ( '/',@docum_numb ,1)
   
IF  @slash = 0
 BEGIN 
   SET @slash = CHARINDEX ( '\',@docum_numb,1)     
 END           

IF ISNULL(@slash,0) > 0                                          
 BEGIN            
  SET @HNUM =  rtrim(ltrim(left(@docum_numb, @slash-1)))
  SET @HNUM2 = rtrim(ltrim(substring(@docum_numb, @slash+1, len(@docum_numb)) ))
 END
ELSE
 BEGIN
  SET @HNUM =  rtrim(ltrim(@docum_numb))
  SET @HNUM2 =  ''       
 END
 
--3
SELECT top 1 -- FIX	  : 17.12.14 Dm  top 1   볺 
  @HNAMEBUY =  case when isnull (e.ENTERPRISE_NAMEDOC,'') <> '' then e.ENTERPRISE_NAMEDOC
                    when isnull (e.ENTERPRISE_NAME,'') <> '' then e.ENTERPRISE_NAME end,
  @HKBUY = ltrim(rtrim(e.ENTERPRISE_TAXNUMB)),
  @HLOCBUY = ltrim(rtrim(ISNULL(e_a.TOWN_NAME,''))) + ' '+ ltrim(rtrim(isnull(e_a.ENTER_ADDR_ADDRESS,''))),  
  @HTELBUY = ltrim(rtrim(c_e.ENTER_CONN_CONTENT))
FROM ENTERPRISE e
  LEFT JOIN (select e_a.ENTERPRISE_ID,      e_a.ENTER_ADDR_ADDRESS,
                    e_a.ENTER_ADDR_DEFAULT, t.TOWN_NAME
         from ENTER_ADDR  e_a
              LEFT JOIN TOWN t on e_a.TOWN_ID = t.TOWN_ID) as e_a
       on e.ENTERPRISE_ID = e_a.ENTERPRISE_ID
  LEFT JOIN (select c_e.ENTERPRISE_ID,      c_e.CONN_TYPE_ID,
                    c_e.ENTER_CONN_CONTENT, c_e.ENTER_CONN_DEFAULT
         from CONNECT_ENT c_e, TYPE_CONNECT tc
         where tc.CONN_TYPE_ID = c_e.CONN_TYPE_ID
           and tc.CONN_TYPE_MOD = 3 ) as c_e
       on c_e.ENTERPRISE_ID = e.ENTERPRISE_ID
 WHERE  e.ENTERPRISE_ID = @ENTERPRISE_ID
order by c_e.ENTER_CONN_DEFAULT desc, e_a.ENTER_ADDR_DEFAULT desc 


if  isnull(@HTELBUY, '') <> ''
begin
  set @coma = CHARINDEX(',' ,@HTELBUY)
  if isnull(@coma,0) <> 0
    begin
      set @HTELBUY = left(@HTELBUY,@coma) --   ,   -                                                                                                                                                                                                                    
    end
  set @HTELBUY = REPLACE (@HTELBUY, '-', '')
  set @HTELBUY = REPLACE (@HTELBUY, ' ', '')      
  set @HTELBUY = REPLACE (@HTELBUY, ')', '')
  set @HTELBUY = REPLACE (@HTELBUY, '(', '')      
end

set @HTELBUY = right(@HTELBUY,10)

--4 
SELECT
  @HNAMESEL =  case when isnull (e.ENTERPRISE_NAMEDOC,'') <> '' then e.ENTERPRISE_NAMEDOC
                    when isnull (e.ENTERPRISE_NAME,'') <> '' then e.ENTERPRISE_NAME
                    else se.SELFENTER_NAME end,
  @HKSEL =  ltrim(rtrim(e.ENTERPRISE_TAXNUMB)),
  @HLOCSEL = ltrim(rtrim(ISNULL(e_a.TOWN_NAME,''))) + ' '+ ltrim(rtrim(isnull(e_a.ENTER_ADDR_ADDRESS,''))),
  @HTELSEL = ltrim(rtrim(c_e.ENTER_CONN_CONTENT))
FROM SELF_ENTERPRISE se
  left join ENTERPRISE  e   on se.ENTERPRISE_ID = e.ENTERPRISE_ID
  LEFT JOIN (select e_a.ENTERPRISE_ID,      e_a.ENTER_ADDR_ADDRESS,
                    e_a.ENTER_ADDR_DEFAULT, t.TOWN_NAME
         from ENTER_ADDR  e_a
              LEFT JOIN TOWN t on e_a.TOWN_ID = t.TOWN_ID) as e_a
       on e.ENTERPRISE_ID = e_a.ENTERPRISE_ID
  LEFT JOIN (select c_e.ENTERPRISE_ID,      c_e.CONN_TYPE_ID,
                    c_e.ENTER_CONN_CONTENT, c_e.ENTER_CONN_DEFAULT
         from CONNECT_ENT c_e, TYPE_CONNECT tc
         where tc.CONN_TYPE_ID = c_e.CONN_TYPE_ID
           and tc.CONN_TYPE_MOD = 3 ) as c_e
       on c_e.ENTERPRISE_ID = e.ENTERPRISE_ID
WHERE se.SELFENTER_ID = @SELFENTER_ID
order by c_e.ENTER_CONN_DEFAULT desc, e_a.ENTER_ADDR_DEFAULT desc 
 
if  isnull(@HTELSEL, '') <> ''
begin
  set @coma = CHARINDEX(',' ,@HTELSEL)
  if isnull(@coma,0) <> 0
      set @HTELSEL = left(@HTELSEL,@coma) --   ,   -   
  set @HTELSEL = REPLACE (@HTELSEL, '-', '')
  set @HTELSEL = REPLACE (@HTELSEL, ' ', '')      
  set @HTELSEL = REPLACE (@HTELSEL, ')', '')
  set @HTELSEL = REPLACE (@HTELSEL, '(', '')      
end

set @HTELSEL = right(@HTELSEL,10)

--5 -
        SET @slash = 0
        SET @slash = CHARINDEX ('',@docum_basis,1)
          
        IF  @slash = 0
           SET @slash = CHARINDEX ('N',@docum_basis,1)     

         SELECT @TYPE_NOTE_NAME = t.TYPE_NOTE_NAME          
         FROM NOTE_INVOICE_TAX i
          INNER JOIN TYPE_NOTE t ON i.TYPE_NOTE_ID = t.TYPE_NOTE_ID                                                                                                                                           
         WHERE i.DOCUM_ID = @docum_id and 
             ( UPPER(left(ltrim(t.TYPE_NOTE_NAME),7))= '²' OR -- UKR
               UPPER(left(ltrim(t.TYPE_NOTE_NAME),7))= 'I' )  -- ENG                                                                                                                          

         IF  @TYPE_NOTE_NAME is not null --10.06.2011                          
           BEGIN
             SET @H01G1S = @TYPE_NOTE_NAME                                                     
           END
         ELSE
           BEGIN
             SELECT @H01G1S =  constuser_value
               from constants_user
              where constuser_id='CONTRACT_TYPE_DEF'  
            END     

        IF @slash > 0
         BEGIN
           IF isnull(@H01G1S,'') = ''
            BEGIN
              SET @H01G1S = left(@docum_basis, @slash-1)               
            END

           SET @docum_basis = substring(@docum_basis,@slash+1,250)        

           SET @slash = CHARINDEX ('.',@docum_basis,1) - 2
           IF @slash > 0 
             BEGIN
              SET @H01G2D =left(replace(substring(@docum_basis,@slash,250), '.', ''),8)
              SET @docum_basis = LTRIM(LEFT(@docum_basis,@slash))  
              
              SET @slash = CHARINDEX (' ',@docum_basis,1)
              IF @slash <> 0
                  SET @H01G3S = LEFT(@docum_basis,@slash-1)
              ELSE
                  SET @H01G3S = @docum_basis
             END
           ELSE 
             BEGIN 
               SET @H01G3S = rtrim(@docum_basis)
               SET @H01G2D = ''
             END 
          
         END
        ELSE
         BEGIN
           SET @H01G1S = isnull(@H01G1S,@docum_basis)  
           SET @H01G3S = '-'
           SET @H01G2D = ''       
         END

        IF @H01G3S = '' 
          SET @H01G3S = '-' 
  
--      
SET @C_DOC_VER= '6'
IF @C_DOC_TYPE <> '0'
   SET @C_DOC_TYPE =  cast((cast(@C_DOC_TYPE as int) +1) as varchar(2))

SET @C_DOC_CNT= @HNUM
SET @C_DOC_STAN = '1'
set @HNAMESEL = REPLACE (@HNAMESEL, '&', '&amp;')
set @HNAMEBUY = REPLACE (@HNAMEBUY, '&', '&amp;')
set @HLOCSEL  = REPLACE (@HLOCSEL,  '&', '&amp;')
set @HLOCBUY  = REPLACE (@HLOCBUY,  '&', '&amp;')
set @H10G1S   = REPLACE (@H10G1S ,  '&', '&amp;')

set @HNAMESEL = REPLACE (@HNAMESEL, '"', '&quot;')
set @HNAMEBUY = REPLACE (@HNAMEBUY, '"', '&quot;')
set @HLOCSEL  = REPLACE (@HLOCSEL,  '"', '&quot;')
set @HLOCBUY  = REPLACE (@HLOCBUY,  '"', '&quot;')
set @H10G1S   = REPLACE (@H10G1S ,  '"', '&quot;')

set @HNAMESEL = REPLACE (@HNAMESEL, '<', '&lt;')
set @HNAMEBUY = REPLACE (@HNAMEBUY, '<', '&lt;')
set @HLOCSEL  = REPLACE (@HLOCSEL,  '<', '&lt;')
set @HLOCBUY  = REPLACE (@HLOCBUY,  '<', '&lt;')
set @H10G1S   = REPLACE (@H10G1S ,  '<', '&lt;')

set @HNAMESEL = REPLACE (@HNAMESEL, '>', '&gt;')
set @HNAMEBUY = REPLACE (@HNAMEBUY, '>', '&gt;')
set @HLOCSEL  = REPLACE (@HLOCSEL,  '>', '&gt;')
set @HLOCBUY  = REPLACE (@HLOCBUY,  '>', '&gt;')
set @H10G1S   = REPLACE (@H10G1S ,  '>', '&gt;')

set @HNAMESEL = REPLACE (@HNAMESEL, '''', '&apos;')
set @HNAMEBUY = REPLACE (@HNAMEBUY, '''', '&apos;')
set @HLOCSEL  = REPLACE (@HLOCSEL,  '''', '&apos;')
set @HLOCBUY  = REPLACE (@HLOCBUY,  '''', '&apos;')
set @H10G1S   = REPLACE (@H10G1S ,  '''', '&apos;')

--  
insert into #opzxml_lines (line_text) values
  ('<?xml version="1.0" encoding="windows-1251"?>')
--  
set @XSD = '<DECLAR xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:noNamespaceSchemaLocation="'
         + @XSD +'">'
insert into #opzxml_lines (line_text) values ( @XSD )
insert into #opzxml_lines (line_text) values ('<DECLARHEAD>')  
insert into #opzxml_lines (line_text) values ('<TIN>'+ @TIN +'</TIN>')  
insert into #opzxml_lines (line_text) values ('<C_DOC>'+@C_DOC+'</C_DOC>')  
insert into #opzxml_lines (line_text) values ('<C_DOC_SUB>'+@C_DOC_SUB+'</C_DOC_SUB>')  
insert into #opzxml_lines (line_text) values ('<C_DOC_VER>'+@C_DOC_VER+'</C_DOC_VER>')  
insert into #opzxml_lines (line_text) values ('<C_DOC_TYPE>'+@C_DOC_TYPE+'</C_DOC_TYPE>')  
insert into #opzxml_lines (line_text) values ('<C_DOC_CNT>'+ @C_DOC_CNT +'</C_DOC_CNT>')  
insert into #opzxml_lines (line_text) values ('<C_REG>'+ @C_REG +'</C_REG>')  
insert into #opzxml_lines (line_text) values ('<C_RAJ>'+ @C_RAJ +'</C_RAJ>')  
insert into #opzxml_lines (line_text) values ('<PERIOD_MONTH>'+ @PERIOD_MONTH +'</PERIOD_MONTH>')  
insert into #opzxml_lines (line_text) values ('<PERIOD_TYPE>'+@PERIOD_TYPE+ '</PERIOD_TYPE>')  
insert into #opzxml_lines (line_text) values ('<PERIOD_YEAR>'+ @PERIOD_YEAR +'</PERIOD_YEAR>')  
insert into #opzxml_lines (line_text) values ('<C_STI_ORIG>'+ @C_STI_ORIG +'</C_STI_ORIG>')  
insert into #opzxml_lines (line_text) values ('<C_DOC_STAN>'+ @C_DOC_STAN+ '</C_DOC_STAN>')  
insert into #opzxml_lines (line_text) values ('<LINKED_DOCS'+@NULL_VALUE+ '></LINKED_DOCS>')  
insert into #opzxml_lines (line_text) values ('<D_FILL>'+ @D_FILL +'</D_FILL>')  
insert into #opzxml_lines (line_text) values ('<SOFTWARE'+ @NULL_VALUE+ '></SOFTWARE>')  
insert into #opzxml_lines (line_text) values ('</DECLARHEAD>') 
 
insert into #opzxml_lines (line_text) values ('<DECLARBODY>') 

insert into #opzxml_lines (line_text) values ('<HORIG>'+@HORIG+'</HORIG>')
insert into #opzxml_lines (line_text) values ('<HERPN>'+@HERPN+'</HERPN>')
insert into #opzxml_lines (line_text) values ('<HORIG1'+CASE WHEN @HORIG1='' THEN @NULL_VALUE ELSE '' END +'>'+ @HORIG1+'</HORIG1>')
insert into #opzxml_lines (line_text) values ('<HTYPR'+CASE WHEN @HTYPR='' THEN @NULL_VALUE ELSE ''END +'>'+ @HTYPR+'</HTYPR>')
insert into #opzxml_lines (line_text) values ('<HFILL>'+@HFILL+'</HFILL>')
insert into #opzxml_lines (line_text) values ('<HNUM>'+ @HNUM+ '</HNUM>')
insert into #opzxml_lines (line_text) values ('<HNUM1'+CASE WHEN @HNUM1='' THEN @NULL_VALUE ELSE ''END +'>'+ @HNUM1+'</HNUM1>')
insert into #opzxml_lines (line_text) values ('<HNUM2'+CASE WHEN @HNUM2='' THEN @NULL_VALUE ELSE ''END +'>'+ @HNUM2+'</HNUM2>')
insert into #opzxml_lines (line_text) values ('<HNAMESEL>'+@HNAMESEL+'</HNAMESEL>')
insert into #opzxml_lines (line_text) values ('<HNAMEBUY>'+@HNAMEBUY+'</HNAMEBUY>')
insert into #opzxml_lines (line_text) values ('<HKSEL>'+@HKSEL+'</HKSEL>')
insert into #opzxml_lines (line_text) values ('<HKBUY>'+@HKBUY+'</HKBUY>')
insert into #opzxml_lines (line_text) values ('<HLOCSEL>'+@HLOCSEL+'</HLOCSEL>')
insert into #opzxml_lines (line_text) values ('<HLOCBUY>'+@HLOCBUY+'</HLOCBUY>')
insert into #opzxml_lines (line_text) values ('<HTELSEL>'+@HTELSEL+'</HTELSEL>')
insert into #opzxml_lines (line_text) values ('<HTELBUY>'+@HTELBUY+'</HTELBUY>')
insert into #opzxml_lines (line_text) values ('<H01G1S>'+@H01G1S+'</H01G1S>')
insert into #opzxml_lines (line_text) values ('<H01G2D>'+@H01G2D+'</H01G2D>')
insert into #opzxml_lines (line_text) values ('<H01G3S>'+@H01G3S+'</H01G3S>')
insert into #opzxml_lines (line_text) values ('<H02G1S'+CASE WHEN @H02G1S='' THEN @NULL_VALUE ELSE '' END +'>'+ @H02G1S+'</H02G1S>')

--   1
--		<RXXXXG2D ROWNUM="1">19012012</RXXXXG2D>
--		<RXXXXG2D ROWNUM="2">19012012</RXXXXG2D>

--
--  
--12.5   6 -  (, )  /.
--       ,      ,   6 : "/ ";

SET @ColNumb = 0

WHILE @ColNumb < 10
BEGIN  
  SET @ColNumb = @ColNumb+1
  --PRINT @ColNumb
  DECLARE crLine INSENSITIVE CURSOR FOR
      select CONVERT(varchar(10),LINE_NUMBER),
        case when @ColNumb = 1  then 'RXXXXG2D'
             when @ColNumb = 2  then 'RXXXXG3S'
             when @ColNumb = 3  then 'RXXXXG4'
             when @ColNumb = 4  then 'RXXXXG4S'
             when @ColNumb = 5  then 'RXXXXG5'
             when @ColNumb = 6  then 'RXXXXG6'
             when @ColNumb = 7  then 'RXXXXG7'
             when @ColNumb = 8  then 'RXXXXG109'
             when @ColNumb = 9  then 'RXXXXG8'
             when @ColNumb = 10  then 'RXXXXG9'
             when @ColNumb = 11 then 'RXXXXG10'
             end as CNAME1,
        case when @ColNumb = 1  then @D_FILL
             when @ColNumb = 2  then REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(l.LINE_NAME, '&',  '&amp;')
                                                                                        , '<',  '&lt;')
                                                                                        , '>',  '&gt;')
                                                                                        , '"',  '&quot;')
                                                                                        , '''', '&apos;')
             when @ColNumb = 3  then (SELECT TOP 1 DUTY_TNVED
                                      FROM DUTY d
                                       INNER JOIN DUTY_PLU dp ON d.DUTY_ID = dp.DUTY_ID
                                      WHERE dp.PLU_ID = l.LINE_PLU_ID)
             when @ColNumb = 4  and p.STOCK_TYPE = 0 then m.METRIC_SHNAME
             when @ColNumb = 4  and p.STOCK_TYPE = 5 then ''
             when @ColNumb = 5  and p.STOCK_TYPE = 0 then convert(varchar(30),l.LINE_QUAN)
             when @ColNumb = 5  and p.STOCK_TYPE = 5 then '/ '
             when @ColNumb = 6  then convert(varchar(30),l.LINE_PRICE_HOME)
--[IIF(<fqHeadDoc."    ">==0, <fqSpecDoc."nds">,0)]
             when @ColNumb = 7  and t.INVTAX_TYPE = 0 and t.DOCUM_TAX_PROCENT = 20 then convert(varchar(30),l.LINE_PRICE_HOME*l.LINE_QUAN)
             when @ColNumb = 8  and t.INVTAX_TYPE = 0 and t.DOCUM_TAX_PROCENT = 7  then convert(varchar(30),l.LINE_PRICE_HOME*l.LINE_QUAN)
             when @ColNumb = 9  and t.INVTAX_TYPE = 1  then convert(varchar(30),l.LINE_PRICE_HOME*l.LINE_QUAN)
             when @ColNumb = 10  and t.INVTAX_TYPE = 2  then convert(varchar(30),l.LINE_PRICE_HOME*l.LINE_QUAN)
             when @ColNumb = 11 and t.INVTAX_TYPE = 3  then convert(varchar(30),l.LINE_PRICE_HOME*l.LINE_QUAN)
             else ''
             end as CVAL1  

      from INVOICE_TAX t
          inner join LINE_INVOICE_TAX l ON l.DOCUM_ID = t.DOCUM_ID
          inner join PLU p ON l.LINE_PLU_ID = p.PLU_ID
          left  join METRIC m ON p.METRIC_ID = m.METRIC_ID
          --left join  DUTY_PLU dp ON dp.PLU_ID = l.LINE_PLU_ID
      WHERE t.DOCUM_ID = @DOCUM_ID
  ---
  OPEN crLine
    
    WHILE (1 = 1)
    BEGIN
      FETCH NEXT FROM crLine
        INTO @LINE_NUMBER, @CNAME1, @CVAL1    
      IF @@FETCH_STATUS <> 0
        BREAK  

      if isnull(@CVAL1,'') = '' continue
        
      insert into #opzxml_lines (line_text) values ('<'+@CNAME1 +' ROWNUM="'+@LINE_NUMBER+'">' +ltrim(rtrim(@CVAL1))+ '</'+@CNAME1+'>')  

  -- 
    END
    CLOSE crLine
    DEALLOCATE crLine      
END

--   2
--		<RXXXXG3S ROWNUM="1">19012012</RXXXXG3S>
--		<RXXXXG3S ROWNUM="2">19012012</RXXXXG3S>

SELECT 
       @R01G7 = convert(varchar(30), sum(case when t.INVTAX_TYPE = 0 and t.DOCUM_TAX_PROCENT = 20 then l.LINE_PRICE_HOME*l.LINE_QUAN else 0 end)),
       @R01G109 = convert(varchar(30), sum(case when t.INVTAX_TYPE = 0 and t.DOCUM_TAX_PROCENT = 7 then l.LINE_PRICE_HOME*l.LINE_QUAN else 0 end)),
       @R01G8 = convert(varchar(30), sum(case when t.INVTAX_TYPE = 1 then l.LINE_PRICE_HOME*l.LINE_QUAN else 0 end)),
       @R01G9 = convert(varchar(30), sum(case when t.INVTAX_TYPE = 2 then l.LINE_PRICE_HOME*l.LINE_QUAN else 0 end)),
       @R01G10 =convert(varchar(30), sum(case when t.INVTAX_TYPE = 3 then l.LINE_PRICE_HOME*l.LINE_QUAN else 0 end)),
       @R01G11 =convert(varchar(30), sum(l.LINE_PRICE_HOME*l.LINE_QUAN))
from INVOICE_TAX t
    inner join LINE_INVOICE_TAX l ON l.DOCUM_ID = t.DOCUM_ID    
WHERE t.DOCUM_ID = @DOCUM_ID

IF @R01G7 = '0.00' SET @R01G7 = ''
IF @R01G109 = '0.00' SET @R01G109 = ''
IF @R01G8 = '0.00' SET @R01G8 = ''
IF @R01G9 = '0.00' SET @R01G9 = ''
IF @R01G10 = '0.00' SET @R01G10= ''
IF @R02G11 = '0.00' SET @R02G11= '' 

IF @R03G7  = '0.00' SET @R03G7  = ''
IF @R03G109  = '0.00' SET @R03G109  = ''
IF @R03G8  = '0.00' SET @R03G8  = ''
IF @R03G9  = '0.00' SET @R03G9  = ''
IF @R03G11 = '0.00' SET @R03G11 = ''

insert into #opzxml_lines (line_text) values ('<R01G7'+  CASE WHEN @R01G7='' THEN @NULL_VALUE  ELSE '' END +'>'+ @R01G7+'</R01G7>')
insert into #opzxml_lines (line_text) values ('<R01G109'+  CASE WHEN @R01G109='' THEN @NULL_VALUE  ELSE '' END +'>'+ @R01G109+'</R01G109>')
insert into #opzxml_lines (line_text) values ('<R01G8'+  CASE WHEN @R01G8='' THEN @NULL_VALUE  ELSE '' END +'>'+ @R01G8+'</R01G8>')
insert into #opzxml_lines (line_text) values ('<R01G9'+  CASE WHEN @R01G9='' THEN @NULL_VALUE  ELSE '' END +'>'+ @R01G9+'</R01G9>')
insert into #opzxml_lines (line_text) values ('<R01G10'+ CASE WHEN @R01G10='' THEN @NULL_VALUE ELSE '' END +'>'+ @R01G10+'</R01G10>')
insert into #opzxml_lines (line_text) values ('<R01G11'+ CASE WHEN @R01G11='' THEN @NULL_VALUE ELSE '' END +'>'+ @R01G11+'</R01G11>')
insert into #opzxml_lines (line_text) values ('<R02G11'+ CASE WHEN @R02G11='' THEN @NULL_VALUE ELSE '' END +'>'+ @R02G11+'</R02G11>')
insert into #opzxml_lines (line_text) values ('<R03G7'+  CASE WHEN @R03G7='' THEN @NULL_VALUE  ELSE '' END +'>'+ @R03G7+'</R03G7>')
insert into #opzxml_lines (line_text) values ('<R03G109'+  CASE WHEN @R03G109='' THEN @NULL_VALUE  ELSE '' END +'>'+ @R03G109+'</R03G109>')
insert into #opzxml_lines (line_text) values ('<R03G8'+  CASE WHEN @R03G8='' THEN @NULL_VALUE  ELSE '' END +'>'+ @R03G8+'</R03G8>')
insert into #opzxml_lines (line_text) values ('<R03G9'+  CASE WHEN @R03G9='' THEN @NULL_VALUE  ELSE '' END +'>'+ @R03G9+'</R03G9>')
insert into #opzxml_lines (line_text) values ('<R03G10S'+CASE WHEN @R03G10S='' THEN @NULL_VALUE   ELSE '' END +'>'+ @R03G10S+'</R03G10S>')
insert into #opzxml_lines (line_text) values ('<R03G11'+ CASE WHEN @R03G11='' THEN @NULL_VALUE    ELSE '' END +'>'+ @R03G11+'</R03G11>')
insert into #opzxml_lines (line_text) values ('<R04G7'+  CASE WHEN @R04G7='' THEN @NULL_VALUE     ELSE '' END +'>'+ @R04G7+'</R04G7>')
insert into #opzxml_lines (line_text) values ('<R04G109'+  CASE WHEN @R04G109='' THEN @NULL_VALUE     ELSE '' END +'>'+ @R04G109+'</R04G109>')
insert into #opzxml_lines (line_text) values ('<R04G8'+  CASE WHEN @R04G8='' THEN @NULL_VALUE     ELSE '' END +'>'+ @R04G8+'</R04G8>')
insert into #opzxml_lines (line_text) values ('<R04G9'+  CASE WHEN @R04G9='' THEN @NULL_VALUE     ELSE '' END +'>'+ @R04G9+'</R04G9>')
insert into #opzxml_lines (line_text) values ('<R04G10'+ CASE WHEN @R04G10='' THEN @NULL_VALUE    ELSE '' END +'>'+ @R04G10+'</R04G10>')
insert into #opzxml_lines (line_text) values ('<R04G11'+ CASE WHEN @R04G11='' THEN @NULL_VALUE    ELSE '' END +'>'+ @R04G11+'</R04G11>')
insert into #opzxml_lines (line_text) values ('<R003G10S'+CASE WHEN @R003G10S='' THEN @NULL_VALUE ELSE '' END +'>'+ @R003G10S+'</R003G10S>')
insert into #opzxml_lines (line_text) values ('<H10G1S'+ CASE WHEN @H10G1S='' THEN @NULL_VALUE    ELSE '' END +'>'+ @H10G1S+'</H10G1S>')
    
insert into #opzxml_lines (line_text) values ('</DECLARBODY>')
insert into #opzxml_lines (line_text) values ('</DECLAR>')

SET @FILE_NAME = @C_REG + 
                 @C_RAJ +
                 right('000000000'+@TIN,10)+
                 @C_DOC +
                 @C_DOC_SUB +
                 right('00'+ @C_DOC_VER,2) +
                 @C_DOC_STAN +
                 right('00'+ @C_DOC_TYPE,2) +
                 right('0000000'+@C_DOC_CNT,7) +
                 @PERIOD_TYPE +
                 right('00'+@PERIOD_MONTH,2) +
                 @PERIOD_YEAR +
                 @C_STI_ORIG + 
                 '.xml'
          
finish:


RETURN @RESULT
---------------------------------------------------------------------
GO

GRANT ALL ON _OPZXML_EXPORTTAXSALEDONE TO ROLE_TWAPP
GRANT ALL ON _OPZXML_EXPORTTAXSALE TO ROLE_TWAPP
GO

exec ALTER_RUN @ALT_DATE = '20141215', @ALT_NUMB = 1, @GRANT = 0, @ALT_NOTE = ' . -  6'
GO
